/**
  This class implements LogCapable interface for message of types that have to be discarded.
  Designed to mute messages of certain types in EventLogService. 
  */

public class BlackHole implements LogCapable
{

/** 
  This method will be called by the EventLogService application to discard a message
  of a specific type (as configured at startup).
  <P>
  Please, note that this method should not be called directly (i.e., locally) by any program.

  @param aHost Host name the application is running on
  @param aType Message type
  @param aSource Source name
  @param aMessage Text message
  */

public synchronized void log(String aHost, String aType, String aSource, String aMessage)
    {
	// Nothing!
    }
}


