unit EXPAT;
{**************************************************************************}
{                                                                          }
{    This C DLL header file first (automatic) conversion generated by:     }
{    HeadConv 4.0 (c) 2000 by Bob Swart (aka Dr.Bob - www.drbob42.com)     }
{      Final Delphi-Jedi (Darth) command-line units edition                }
{                                                                          }
{    Generated Date: 10/02/2001                                            }
{    Generated Time: 11:22:30                                              }
{                                                                          }
{**************************************************************************}
//
// Extensive hand editing and correcting by Danny Heijl
// Feb 10, 2001 Danny.Heijl@pandora.be
//
//


interface
uses
{$IFDEF WIN32}
  Windows;
{$ELSE}
  //
{$ENDIF}


{=   > EXPAT.H <=}

{+// }
{-Copyright (c) 1998, 1999, 2000 Thai Open Source Software Center Ltd }
{-See the file COPYING for copying permission. }
{=    }

// for compatibility with C enum :

{$MINENUMSIZE 4}

const
  XmlParse_INCLUDED = 1;


type
  TXML_Parser = Pointer;
  PXML_Parser = ^TXML_Parser;

{+// Information is UTF-8 encoded.*/ }
type
  TXML_Char = Char;
  PXML_Char = PChar;
type
  TXML_LChar = Char;
  PXML_LChar = PChar;

type
  TXML_Content_Type = (
    XML_CTYPE_ILLEGAL {dh},
    XML_CTYPE_EMPTY   {=1},
    XML_CTYPE_ANY,
    XML_CTYPE_MIXED,
    XML_CTYPE_NAME,
    XML_CTYPE_CHOICE,
    XML_CTYPE_SEQ);

type
  TXML_Content_Quant = (
    XML_CQUANT_NONE,
    XML_CQUANT_OPT,
    XML_CQUANT_REP,
    XML_CQUANT_PLUS);

{+// If type == XML_CTYPE_EMPTY or XML_CTYPE_ANY, then quant will be }
{-   XML_CQUANT_NONE, and the other fields will be zero or NULL. }
{-   If type == XML_CTYPE_MIXED, then quant will be NONE or REP and }
{-   numchildren will contain number of elements that may be mixed in }
{-   and children point to an array of XML_Content cells that will be }
{-   all of XML_CTYPE_NAME type with no quantification. }

{-   If type == XML_CTYPE_NAME, then the name points to the name, and }
{-   the numchildren field will be zero and children will be NULL. The }
{-   quant fields indicates any quantifiers placed on the name. }

{-   CHOICE and SEQ will have name NULL, the number of children in }
{-   numchildren and children will point, recursively, to an array }
{-   of XML_Content cells. }

{-   The EMPTY, ANY, and MIXED types will only occur at top level. }
{=    }

type
//  TXML_Content = record;
  PXML_Content = ^TXML_cp;
  TXML_cp = record
    _type:      TXML_Content_Type;
    quant:      TXML_Content_Quant;
    name:       PXML_Char;
    numchildren:Cardinal;
    children:   PXML_Content;
  end;


{+// This is called for an element declaration. See above for }
{-   description of the model argument. It's the caller's responsibility }
{-   to free model when finished with it. }
{=    }

type
  TXML_ElementDeclhandler = procedure (userData : Pointer;
                                       const name: PXML_Char;
                                       model: PXML_Content)
                                       cdecl;
  procedure XML_SetElementDeclhandler(parser: TXML_Parser;
                                      eldecl: TXML_ElementDeclHandler)
                                      cdecl;
{+// }
{-  The Attlist declaration handler is called for*each* attribute. So }
{-  a single Attlist declaration with multiple attributes declared will }
{-  generate multiple calls to this handler. The "default" parameter }
{   may be NULL in the case of the "#IMPLIED" or "#REQUIRED" keyword. }
{-  The "isrequired" parameter will be true and the default value will }
{   be NULL in the case of "#REQUIRED". If "isrequired" is true and }
{   default is non-NULL, then this is a "#FIXED" default. }
{=    }

type
  TXML_AttlistDeclHandler = procedure (userData: pointer;
                                       const elname: PXML_Char;
                                       const attname: PXML_Char;
                                       const att_type: PXML_Char;
                                       const dflt: PXML_Char;
                                       isrequired: integer) cdecl;


  procedure XML_SetAttlistDeclHandler(parser: TXML_Parser;
                                      attdecl: TXML_AttlistDeclHandler)
                                      cdecl;

{+// The XML declaration handler is called for*both* XML declarations and }
{-   text declarations. The way to distinguish is that the version parameter }
{-   will be null for text declarations. The encoding parameter may be null }
{-   for XML declarations. The standalone parameter will be -1, 0, or 1 }
{-   indicating respectively that there was no standalone parameter in }
{-   the declaration, that it was given as no, or that it was given as yes. }
{=    }

type
  TXML_XmlDeclHandler = procedure (userData: Pointer;
				             const version: TXML_Char;
				             const encoding: TXML_Char;
                                   standalone: integer)
                                   cdecl;


  procedure XML_SetXmlDeclHandler(parser: TXML_Parser;
                                  xmldecl: TXML_XMLdeclHandler)
                                  cdecl;

{+// Constructs a new parser; encoding is the encoding specified by the external }
{=      protocol or null if there is none specified. }

  function XML_ParserCreate(const encoding: PXML_Char): TXML_Parser
                            cdecl;

{+// Constructs a new parser and namespace processor. Element type names }
{-   and attribute names that belong to a namespace will be expanded; }
{-   unprefixed attribute names are never expanded; unprefixed element type }
{-   names are expanded only if there is a default namespace. The expanded }
{-   name is the concatenation of the namespace URI, the namespace separator character, }
{-   and the local part of the name. If the namespace separator is '\0' then }
{-   the namespace URI and the local part will be concatenated without any }
{-   separator. When a namespace is not declared, the name and prefix will be }
{=      passed through without expansion. }

  function XML_ParserCreateNS(const encoding: PXML_Char;
                              namespaceSeparator: TXML_Char): TXML_Parser
                              cdecl;


{+// Constructs a new parser using the memory management suit referred to }
{-   by memsuite. If memsuite is NULL, then use the standard library memory }
{-   suite. If namespaceSeparator is non-NULL it creates a parser with }
{-   namespace processing as described above. The character pointed at }
{-   will serve as the namespace separator. }

{-   All further memory operations used for the created parser will come from }
{-   the given suite. }
{=    }

type
  TMalloc_fcn   = function(size: Cardinal): Pointer
                  cdecl;
  TRealloc_fcn  = function(ptr: Pointer; size: Cardinal): Pointer
                  cdecl;
  TFree_fcn     = procedure(ptr: pointer)
                  cdecl;

  PXML_Memory_Handling_Suite = ^TXML_Memory_Handling_Suite;
  TXML_Memory_Handling_Suite = record
    malloc_fcn: TMalloc_fcn;
    realloc_fcn: TRealloc_fcn;
    free_fcn: TFRee_fcn;
  end;

  function XML_ParserCreate_MM(const encoding: PXML_Char;
                               const memsuite: PXML_Memory_Handling_Suite;
                               const namespaceSeparator: PXML_Char): TXML_Parser
                               cdecl;

{+// attrs is array of name/value pairs, terminated by 0; }
{=      names and values are 0 terminated. }

type
  TAttrs= Array of Pchar;

  TXML_StartElementHandler  = procedure(userData: Pointer;
                                        const name: PXML_Char;
                                        const atts: TAttrs)
                                        cdecl;

  TXML_EndElementHandler    = procedure(userData: Pointer;
                                        const name: PXML_Char)
                                        cdecl;

{+// s is not 0 terminated.*/ }
  TXML_CharacterDataHandler = procedure(userData: Pointer;
					            const s: PXML_Char;
                                        len: integer)
                                        cdecl;

{+// target and data are 0 terminated*/ }
  TXML_ProcessingInstructionHandler = procedure(userData: Pointer;
						              const target: PXML_Char;
                                                const data: PXML_Char)
                                                cdecl;

{+// data is 0 terminated*/ }
  TXML_CommentHandler           = procedure(userData: Pointer;
                                            const data: PXML_Char)
                                            cdecl;
  TXML_StartCdataSectionHandler = procedure(userData: Pointer)
                                            cdecl;
  TXML_EndCdataSectionHandler   = procedure(userData: Pointer)
                                            cdecl;

{+// This is called for any characters in the XML document for }
{-   which there is no applicable handler. This includes both }
{-   characters that are part of markup which is of a kind that is }
{-   not reported (comments, markup declarations), or characters }
{-   that are part of a construct which could be reported but }
{-   for which no handler has been supplied. The characters are passed }
{-   exactly as they were in the XML document except that }
{-   they will be encoded in UTF-8. Line boundaries are not normalized. }
{-   Note that a byte order mark character is not passed to the default handler. }
{-   There are no guarantees about how characters are divided between calls }
{-   to the default handler: for example, a comment might be split between }
{=      multiple calls. }

  TXML_DefaultHandler = procedure(userData: Pointer;
                                  const s: PXML_Char;
                                  len: integer)
                                  cdecl;

{+// This is called for the start of the DOCTYPE declaration, before }
{=      any DTD or internal subset is parsed. }

  TXML_StartDoctypeDeclHandler = procedure(userData: Pointer;
                  				   const doctypeName: PXML_Char;
    					         const sysid: PXML_Char;
    					         const pubid: PXML_Char;
    					         has_internal_subset: integer)
                                           cdecl;

{+// This is called for the start of the DOCTYPE declaration when the }
{=      closing > is encountered, but after processing any external subset. }

  TXML_EndDoctypeDeclHandler = procedure(userData: Pointer)
                                         cdecl;

{+// This is called for entity declarations. The is_parameter_entity }
{-   argument will be non-zero if the entity is a parameter entity, zero }
{-   otherwise. }

{-   For internal entities (<!ENTITY foo "bar">), value will }
{-   be non-null and systemId, publicID, and notationName will be null. }
{-   The value string is NOT null terminated; the length is provided in }
{-   the value_length argument. Since it is legal to have zero-length }
{-   values, do not use this argument to test for internal entities. }

{-   For external entities, value will be null and systemId will be non-null. }
{-   The publicId argument will be null unless a public identifier was }
{-   provided. The notationName argument will have a non-null value only }
{-   for unparsed entity declarations. }
{=    }

  TXML_EntityDeclHandler = procedure(userData: Pointer;
                                     const entityName: PXML_Char;
				               is_parameter_entity: integer;
				               const value: PXML_Char;
				               value_length: integer;
				               const base: PXML_Char;
				               const systemId: PXML_Char;
				               const publicId: PXML_Char;
				               const notationName: PXML_Char)
                                     cdecl;

  procedure XML_SetEntityDeclHandler(parser: TXML_Parser;
           	                     handler: TXML_EntityDeclHandler)
                                     cdecl;

{+// OBSOLETE -- OBSOLETE -- OBSOLETE }
{-   This handler has been superceded by the EntityDeclHandler above. }
{-   It is provided here for backward compatibility. }
{-   This is called for a declaration of an unparsed (NDATA) }
{-   entity. The base argument is whatever was set by XML_SetBase. }
{-   The entityName, systemId and notationName arguments will never be null. }
{=      The other arguments may be. }

type
  TXML_UnparsedEntityDeclHandler = procedure(
                                  userData: Pointer;
					      const entityName: PXML_Char;
					      const base: PXML_Char;
					      const systemId: PXML_Char;
					      const publicId: PXML_Char;
					      const notationName: PXML_Char)
                                  cdecl;

{+// This is called for a declaration of notation. }
{-   The base argument is whatever was set by XML_SetBase. }
{=      The notationName will never be null. The other arguments can be. }

  TXML_NotationDeclHandler = procedure(
                            userData: Pointer;
					const notationName: PXML_Char;
                            const base: PXML_Char;
                            const systemId: PXML_Char;
                            const publicId: PXML_Char)
                            cdecl;

{+// When namespace processing is enabled, these are called once for }
{-   each namespace declaration. The call to the start and end element }
{-   handlers occur between the calls to the start and end namespace }
{-   declaration handlers. For an xmlns attribute, prefix will be null. }
{=      For an xmlns="" attribute, uri will be null. }

  TXML_StartNamespaceDeclHandler = procedure(
                                   userData: pointer;
					       const prefix: PXML_Char;
					       const uri: PXML_Char)
                                   cdecl;

  TXML_EndNamespaceDeclHandler = procedure(
                                 userData: Pointer;
					     const prefix: PXML_Char)
                                 cdecl;

{+// This is called if the document is not standalone (it has an }
{-   external subset or a reference to a parameter entity, but does not }
{-   have standalone="yes"). If this handler returns 0, then processing }
{-   will not continue, and the parser will return a }
{=      XML_ERROR_NOT_STANDALONE error. }

  TXML_NotStandaloneHandler = function(userData: Pointer): integer
                                       cdecl;


{+// This is called for a reference to an external parsed general entity. }
{-   The referenced entity is not automatically parsed. }
{-   The application can parse it immediately or later using }
{-   XML_ExternalEntityParserCreate. }
{-   The parser argument is the parser parsing the entity containing the reference; }
{-   it can be passed as the parser argument to XML_ExternalEntityParserCreate. }
{-   The systemId argument is the system identifier as specified in the entity declaration; }
{-   it will not be null. }
{-   The base argument is the system identifier that should be used as the base for }
{-   resolving systemId if systemId was relative; this is set by XML_SetBase; }
{-   it may be null. }
{-   The publicId argument is the public identifier as specified in the entity declaration, }
{-   or null if none was specified; the whitespace in the public identifier }
{-   will have been normalized as required by the XML spec. }
{-   The context argument specifies the parsing context in the format }
{-   expected by the context argument to }
{-   XML_ExternalEntityParserCreate; context is valid only until the handler }
{-   returns, so if the referenced entity is to be parsed later, it must be copied. }
{-   The handler should return 0 if processing should not continue because of }
{-   a fatal error in the handling of the external entity. }
{-   In this case the calling parser will return an XML_ERROR_EXTERNAL_ENTITY_HANDLING }
{-   error. }
{=      Note that unlike other handlers the first argument is the parser, not userData. }

  TXML_ExternalEntityRefHandler = function(
                                parser: TXML_Parser;
					    const context: PXML_Char;
					    const base: PXML_Char;
					    const systemId: PXML_Char;
					    const publicId: PXML_Char): integer
                                cdecl;

{+// This structure is filled in by the XML_UnknownEncodingHandler }
{-   to provide information to the parser about encodings that are unknown }
{-   to the parser. }
{-   The map[b] member gives information about byte sequences }
{-   whose first byte is b. }
{-   If map[b] is c where c is >= 0, then b by itself encodes the Unicode scalar value c. }
{-   If map[b] is -1, then the byte sequence is malformed. }
{-   If map[b] is -n, where n >= 2, then b is the first byte of an n-byte }
{-   sequence that encodes a single Unicode scalar value. }
{-   The data member will be passed as the first argument to the convert function. }
{-   The convert function is used to convert multibyte sequences; }
{-   s will point to a n-byte sequence where map[(unsigned char)*s] == -n. }
{-   The convert function must return the Unicode scalar value }
{-   represented by this byte sequence or -1 if the byte sequence is malformed. }
{-   The convert function may be null if the encoding is a single-byte encoding, }
{-   that is if map[b] >= -1 for all bytes b. }
{-   When the parser is finished with the encoding, then if release is not null, }
{-   it will call release passing it the data member; }
{-   once release has been called, the convert function will not be called again. }

{-   Expat places certain restrictions on the encodings that are supported }
{-   using this mechanism. }

{-   1. Every ASCII character that can appear in a well-formed XML document, }
{-   other than the characters }

(*   $@\^`{}~ *)

{-   must be represented by a single byte, and that byte must be the }
{-   same byte that represents that character in ASCII. }

{-   2. No character may require more than 4 bytes to encode. }

{-   3. All characters encoded must have Unicode scalar values <= 0xFFFF, }
{-   (ie characters that would be encoded by surrogates in UTF-16 }
{-   are not allowed). Note that this restriction doesn't apply to }
{-   the built-in support for UTF-8 and UTF-16. }

{-   4. No Unicode character may be encoded by more than one distinct sequence }
{=   of bytes. }

  TConvert = function(data: Pointer; s: Pchar): integer
                      cdecl;
  TRelease = procedure(data: Pointer)
                      cdecl;

  TXML_Encoding = record
    map: Array[0..256-1] of Integer;
    data: Pointer;
    convert: TConvert;
    release: TRelease;
  end;

{+// This is called for an encoding that is unknown to the parser. }
{-   The encodingHandlerData argument is that which was passed as the }
{-   second argument to XML_SetUnknownEncodingHandler. }
{-   The name argument gives the name of the encoding as specified in }
{-   the encoding declaration. }
{-   If the callback can provide information about the encoding, }
{-   it must fill in the XML_Encoding structure, and return 1. }
{-   Otherwise it must return 0. }
{-   If info does not describe a suitable encoding, }
{=   then the parser will return an XML_UNKNOWN_ENCODING error. }

  TXML_UnknownEncodingHandler = function(
                              encodingHandlerData: Pointer;
					  const name: PXML_Char;
					  info: TXML_Encoding): integer
                              cdecl;

  procedure XML_SetElementHandler(parser: TXML_Parser;
                                  start: TXML_StartElementHandler;
                                  _end: TXML_EndElementHandler)
                                  cdecl;


  procedure XML_SetStartElementhandler(parser: TXML_Parser;
                                        handler: TXML_StartElementHandler)
                                        cdecl;

  procedure XML_SetEndElementHandler(parser: TXML_Parser;
                                     handler: TXML_EndElementHandler)
                                     cdecl;

  procedure XML_SetCharacterDataHandler(parser: TXML_Parser;
                                        handler: TXML_CharacterDataHandler)
                                        cdecl;

  procedure XML_SetProcessingInstructionHandler(parser: TXML_Parser;
                                                handler: TXML_ProcessingInstructionHandler)
                                                cdecl;

  procedure XML_SetCommentHandler(parser: TXML_Parser;
                                  handler: TXML_CommentHandler)
                                  cdecl;

  procedure XML_SetCdataSectionHandler(parser: TXML_Parser;
                                       start: TXML_StartCdataSectionHandler;
                                       _end: TXML_EndCdataSectionHandler)
                                       cdecl;

  procedure XML_SetStartCdataSectionHandler(parser: TXML_Parser;
                                            start: TXML_StartCdataSectionHandler)
                                            cdecl;

  procedure XML_SetEndCdataSectionHandler(parser: TXML_Parser;
                                          _end: TXML_EndCdataSectionHandler)
                                          cdecl;

{+// This sets the default handler and also inhibits expansion of internal entities. }
{=   The entity reference will be passed to the default handler. }

  procedure XML_SetdefaultHandler(parser: TXML_Parser;
                                  handler: TXML_DefaultHandler)
                                  cdecl;

{+// This sets the default handler but does not inhibit expansion of internal entities. }
{=   The entity reference will not be passed to the default handler. }

  procedure XML_SetDefaultHandlerExpand(parser: TXML_Parser;
                                        handler: TXML_DefaultHandler)
                                        cdecl;

  procedure XML_SetDoctypeDeclHandler(
                                 parser: TXML_Parser;
                                 start: TXML_StartDoctypeDeclHandler;
                                 _end: TXML_EndDoctypeDeclHandler)
                                 cdecl;

  procedure XML_SetStartDoctypeDeclHandler(
                                      parser: TXML_Parser;
                                      start: TXML_StartDoctypeDeclHandler)
                                      cdecl;

  procedure XML_SetEndDoctypeDeclHandler(
                                      parser: TXML_Parser;
                                      _end: TXML_EndDoctypeDeclHandler)
                                      cdecl;

  procedure XML_SetUnparsedEntityDeclHandler(
                                   parser: TXML_Parser;
                                   handler: TXML_UnparsedEntityDeclHandler)
                                   cdecl;

  procedure XML_SetNotationDeclHandler(
                                      parser: TXML_Parser;
                                      handler: TXML_NotationDeclHandler)
                                      cdecl;

  procedure XML_SetNameSpaceDeclHandler(
                                      parser: TXML_Parser;
                                      start: TXML_StartNamespaceDeclHandler;
                                      _end: TXML_EndNamespaceDeclHandler)
                                      cdecl;

  procedure XML_SetStartNameSpaceDeclHandler(
                                      parser: TXML_Parser;
                                      start: TXML_StartNamespaceDeclHandler)
                                      cdecl;

  procedure XML_SetEndNameSpaceDeclHandler(
                                      parser: TXML_Parser;
                                      _end: TXML_EndNamespaceDeclHandler)
                                      cdecl;

  procedure XML_SetNotstandaloneHandler(
                                      parser: TXML_Parser;
                                      handler: TXML_NotStandaloneHandler)
                                      cdecl;

  procedure XML_SetExternalEntityRefHandler(
                                      parser: TXML_Parser;
                                      handler: TXML_ExternalEntityRefHandler)
                                      cdecl;

{+// If a non-null value for arg is specified here, then it will be passed }
{-   as the first argument to the external entity ref handler instead }
{=   of the parser object. }

  procedure XML_SetExternalEntityRefHandlerArg(
                                      parser: TXML_Parser;
                                      arg: Pointer)
                                      cdecl;

  procedure XML_SetUnknownEncodingHandler(
                                      parser: TXML_PARSER;
                                      handler: TXML_UnknownEncodingHandler;
                                      encodingHandlerData: Pointer)
                                      cdecl;

{+// This can be called within a handler for a start element, end element, }
{-   processing instruction or character data. It causes the corresponding }
{=   markup to be passed to the default handler. }

procedure XML_DefaultCurrent(parser: TXML_Parser);

{+// If do_nst is non-zero, and namespace processing is in effect, and }
{-   a name has a prefix (i.e. an explicit namespace qualifier) then }
{-   that name is returned as a triplet in a single }
{-   string separated by the separator character specified when the parser }
{-   was created: URI + sep + local_name + sep + prefix. }

{-   If do_nst is zero, then namespace information is returned in the }
{-   default manner (URI + sep + local_name) whether or not the names }
{-   has a prefix. }
{=    }

  procedure XML_SetReturnNSTriplet(parser: TXML_Parser;
                                   do_nst: Integer)
                                   cdecl;

{+// This value is passed as the userData argument to callbacks.*/ }
  procedure XML_SetUserData(parser: TXML_Parser;
                            userData: Pointer)
                            cdecl;

{+// Returns the last value set by XML_SetUserData or null.*/ }
{    #define XML_GetUserData(parser) (*(void **)(parser)) }

  function XML_GetUserData(var parser: TXML_Parser): Pointer;
                           cdecl;


{+// This is equivalent to supplying an encoding argument }
{-   to XML_ParserCreate. It must not be called after XML_Parse }
{=   or XML_ParseBuffer. }
  function XML_SetEncoding(parser: TXML_Parser;
                           const encoding: PXML_Char): Integer
                           cdecl;

{+// If this function is called, then the parser will be passed }
{-   as the first argument to callbacks instead of userData. }
{=   The userData will still be accessible using XML_GetUserData. }
  procedure XML_UseParserAsHandlerArg(parser: TXML_Parser)
                                      cdecl;

{+// Sets the base to be used for resolving relative URIs in system identifiers in }
{-   declarations. Resolving relative identifiers is left to the application: }
{-   this value will be passed through as the base argument to the }
{-   XML_ExternalEntityRefHandler, XML_NotationDeclHandler }
{-   and XML_UnparsedEntityDeclHandler. The base argument will be copied. }
{=   Returns zero if out of memory, non-zero otherwise. }
  function XML_SetBase(parser: TXML_Parser;
                       const base: PXML_Char): Integer
                       cdecl;

  function XML_GetBase(parser: TXML_Parser): PXML_Char
                       cdecl;

{+// Returns the number of the attribute/value pairs passed in last call }
{-   to the XML_StartElementHandler that were specified in the start-tag }
{-   rather than defaulted. Each attribute/value pair counts as 2; thus }
{-   this correspondds to an index into the atts array passed to the }
{=   XML_StartElementHandler. }
  function XML_GetSpecifiedAttributeCount(parser: TXML_Parser): Integer
                                          cdecl;

{+// Returns the index of the ID attribute passed in the last call to }
{-   XML_StartElementHandler, or -1 if there is no ID attribute. Each }
{-   attribute/value pair counts as 2; thus this correspondds to an index }
{=   into the atts array passed to the XML_StartElementHandler. }
  function XML_GetIdAttributeIndex(parser: TXML_Parser): Integer
                                   cdecl;

{+// Parses some input. Returns 0 if a fatal error is detected. }
{-   The last call to XML_Parse must have isFinal true; }
{=   len may be zero for this call (or any other). }
  function XML_Parse (parser: TXML_Parser;
                      const s: PChar;
                      len: Integer;
                      isFinal: Integer): Integer
                      cdecl;

  function XML_GetBuffer(parser: TXML_Parser;
                          len: Integer): Pointer
                          cdecl;

  function XML_ParseBuffer(parser: TXML_Parser;
                           len: Integer;
                           isFinal: Integer): Integer
                           cdecl;

{+// Creates an XML_Parser object that can parse an external general entity; }
{-   context is a '\0'-terminated string specifying the parse context; }
{-   encoding is a '\0'-terminated string giving the name of the externally specified encoding, }
{-   or null if there is no externally specified encoding. }
{-   The context string consists of a sequence of tokens separated by formfeeds (\f); }
{-   a token consisting of a name specifies that the general entity of the name }
{-   is open; a token of the form prefix=uri specifies the namespace for a particular }
{-   prefix; a token of the form =uri specifies the default namespace. }
{-   This can be called at any point after the first call to an ExternalEntityRefHandler }
{-   so longer as the parser has not yet been freed. }
{-   The new parser is completely independent and may safely be used in a separate thread. }
{-   The handlers and userData are initialized from the parser argument. }
{=   Returns 0 if out of memory. Otherwise returns a new XML_Parser object. }
  function XML_ExternalEntityParserCreate(parser: TXML_Parser;
                                          const context: PXML_Char;
                                          const encoding: PXML_Char): TXML_Parser
                                          cdecl;

type
  TXML_ParamEntityParsing = (
    XML_PARAM_ENTITY_PARSING_NEVER,
    XML_PARAM_ENTITY_PARSING_UNLESS_STANDALONE,
    XML_PARAM_ENTITY_PARSING_ALWAYS  );

{+// Controls parsing of parameter entities (including the external DTD }
{-   subset). If parsing of parameter entities is enabled, then references }
{-   to external parameter entities (including the external DTD subset) }
{-   will be passed to the handler set with }
{-   XML_SetExternalEntityRefHandler. The context passed will be 0. }
{-   Unlike external general entities, external parameter entities can only }
{-   be parsed synchronously. If the external parameter entity is to be }
{-   parsed, it must be parsed during the call to the external entity ref }
{-   handler: the complete sequence of XML_ExternalEntityParserCreate, }
{-   XML_Parse/XML_ParseBuffer and XML_ParserFree calls must be made during }
{-   this call. After XML_ExternalEntityParserCreate has been called to }
{-   create the parser for the external parameter entity (context must be 0 }
{-   for this call), it is illegal to make any calls on the old parser }
{-   until XML_ParserFree has been called on the newly created parser. If }
{-   the library has been compiled without support for parameter entity }
{-   parsing (ie without XML_DTD being defined), then }
{-   XML_SetParamEntityParsing will return 0 if parsing of parameter }
{=   entities is requested; otherwise it will return non-zero. }

  function XML_SetParamEntityParsing(parser: TXML_Parser;
                                     parsing: TXML_ParamEntityParsing): integer
                                     cdecl;

type
  TXML_Error = (
    XML_ERROR_NONE,
    XML_ERROR_NO_MEMORY,
    XML_ERROR_SYNTAX,
    XML_ERROR_NO_ELEMENTS,
    XML_ERROR_INVALID_TOKEN,
    XML_ERROR_UNCLOSED_TOKEN,
    XML_ERROR_PARTIAL_CHAR,
    XML_ERROR_TAG_MISMATCH,
    XML_ERROR_DUPLICATE_ATTRIBUTE,
    XML_ERROR_JUNK_AFTER_DOC_ELEMENT,
    XML_ERROR_PARAM_ENTITY_REF,
    XML_ERROR_UNDEFINED_ENTITY,
    XML_ERROR_RECURSIVE_ENTITY_REF,
    XML_ERROR_ASYNC_ENTITY,
    XML_ERROR_BAD_CHAR_REF,
    XML_ERROR_BINARY_ENTITY_REF,
    XML_ERROR_ATTRIBUTE_EXTERNAL_ENTITY_REF,
    XML_ERROR_MISPLACED_XML_PI,
    XML_ERROR_UNKNOWN_ENCODING,
    XML_ERROR_INCORRECT_ENCODING,
    XML_ERROR_UNCLOSED_CDATA_SECTION,
    XML_ERROR_EXTERNAL_ENTITY_HANDLING,
    XML_ERROR_NOT_STANDALONE,
    XML_ERROR_UNEXPECTED_STATE);

{+// If XML_Parse or XML_ParseBuffer have returned 0, then XML_GetErrorCode  );
{=   returns information about the error. }

  function XML_GetErrorCode(parser: TXML_Parser): TXML_Error
                            cdecl;

{+// These functions return information about the current parse location.  );
{-   They may be called when XML_Parse or XML_ParseBuffer return 0; }
{-   in this case the location is the location of the character at which }
{-   the error was detected. }
{-   They may also be called from any other callback called to report }
{-   some parse event; in this the location is the location of the first }
{=   of the sequence of characters that generated the event. }
  function XML_GetCurrentLineNumber(parser: TXML_Parser): Integer
                                    cdecl;
  function XML_GetCurrentColumnNumber(parser: TXML_Parser): Integer
                                      cdecl;
  function XML_GetCurrentByteIndex(parser: TXML_Parser): LongInt
                                   cdecl;
{+// Return the number of bytes in the current event. }
{=   Returns 0 if the event is in an internal entity. }
  function XML_GetCurrentByteCount(parser: TXML_Parser): Integer
                                   cdecl;


{+// If XML_CONTEXT_BYTES is defined, returns the input buffer, sets }
{-   the integer pointed to by offset to the offset within this buffer }
{-   of the current parse position, and sets the integer pointed to by size }
{-   to the size of this buffer (the number of input bytes). Otherwise }
{-   returns a null pointer. Also returns a null pointer if a parse isn't active. }

{-   NOTE: The character pointer returned should not be used outside }
{=   the handler that makes the call. }
  function XML_GetInputContext(parser: TXML_Parser;
                               var offset: Integer;
                               var size: Integer): PChar
                               cdecl;

{+// For backwards compatibility with previous versions.*/ }
// #define XML_GetErrorLineNumber XML_GetCurrentLineNumber
// #define XML_GetErrorColumnNumber XML_GetCurrentColumnNumber
// #define XML_GetErrorByteIndex XML_GetCurrentByteIndex

{+// Frees memory used by the parser.*/ }
  procedure XML_ParserFree(parser: TXML_Parser)
                           cdecl;
{+// Returns a string describing the error.*/ }
  function XML_ErrorString(code: Integer): PXML_LChar
                           cdecl;
{+// Return a string containing the version number of this expat*/ }
  function XML_ExpatVersion: PXML_LChar
                             cdecl;


implementation

type
  TXML_GetUserdata = function: pointer;

function XML_GetUserData(var parser: TXML_Parser): Pointer;
var
  functionpointer: TXML_GetUserdata;
begin
  functionpointer := parser;
  Result := functionpointer;
end;


procedure XML_SetElementDeclHandler;               external 'EXPAT.DLL'
                                                   name 'XML_SetElementDeclHandler';
procedure XML_SetAttlistDeclHandler;               external 'EXPAT.DLL'
                                                   name 'XML_SetAttlistDeclHandler';
procedure XML_SetXmlDeclHandler;                   external 'EXPAT.DLL'
                                                   name 'XML_SetXmlDeclHandler';
function  XML_ParserCreate;                        external 'EXPAT.DLL'
                                                   name 'XML_ParserCreate';
function  XML_ParserCreateNS;                      external 'EXPAT.DLL'
                                                   name 'XML_ParserCreateNS';
function  XML_ParserCreate_MM;                     external 'EXPAT.DLL'
                                                   name 'XML_ParserCreate_MM';
procedure XML_SetEntityDeclHandler;                external 'EXPAT.DLL'
                                                   name 'XML_SetEntityDeclHandler';
procedure XML_SetElementHandler;                   external 'EXPAT.DLL'
                                                   name 'XML_SetElementHandler';
procedure XML_SetStartElementHandler;              external 'EXPAT.DLL'
                                                   name 'XML_SetStartElementHandler';
procedure XML_SetEndElementHandler;                external 'EXPAT.DLL'
                                                   name 'ML_SetEndElementHandler';
procedure XML_SetCharacterDataHandler;             external 'EXPAT.DLL'
                                                   name 'XML_SetCharacterDataHandler';
procedure XML_SetProcessingInstructionHandler;     external 'EXPAT.DLL'
                                                   name 'XML_SetProcessingInstructionHandler';
procedure XML_SetCommentHandler;                   external 'EXPAT.DLL'
                                                   name 'XML_SetCommentHandler';
procedure XML_SetCdataSectionHandler;              external 'EXPAT.DLL'
                                                   name 'XML_SetCdataSectionHandler';
procedure XML_SetStartCdataSectionHandler;         external 'EXPAT.DLL'
                                                   name 'XML_SetStartCdataSectionHandler';
procedure XML_SetEndCdataSectionHandler;           external 'EXPAT.DLL'
                                                   name 'XML_SetEndCdataSectionHandler';
procedure XML_SetDefaultHandler;                   external 'EXPAT.DLL'
                                                   name 'XML_SetDefaultHandler';
procedure XML_SetDefaultHandlerExpand;             external 'EXPAT.DLL'
                                                   name 'XML_SetDefaultHandlerExpand';
procedure XML_SetDoctypeDeclHandler;               external 'EXPAT.DLL'
                                                   name 'XML_SetDoctypeDeclHandler';
procedure XML_SetStartDoctypeDeclHandler;          external 'EXPAT.DLL'
                                                   name 'XML_SetStartDoctypeDeclHandler';
procedure XML_SetEndDoctypeDeclHandler;            external 'EXPAT.DLL'
                                                   name 'XML_SetEndDoctypeDeclHandler';
procedure XML_SetUnparsedEntityDeclHandler;        external 'EXPAT.DLL'
                                                   name 'XML_SetUnparsedEntityDeclHandler';
procedure XML_SetNotationDeclHandler;              external 'EXPAT.DLL'
                                                   name 'XML_SetNotationDeclHandler';
procedure XML_SetNamespaceDeclHandler;             external 'EXPAT.DLL'
                                                   name 'XML_SetNamespaceDeclHandler';
procedure XML_SetStartNamespaceDeclHandler;        external 'EXPAT.DLL'
                                                   name 'XML_SetStartNamespaceDeclHandler';
procedure XML_SetEndNamespaceDeclHandler;          external 'EXPAT.DLL'
                                                   name 'XML_SetEndNamespaceDeclHandler';
procedure XML_SetNotStandaloneHandler;             external 'EXPAT.DLL'
                                                   name 'XML_SetNotStandaloneHandler';
procedure XML_SetExternalEntityRefHandler;         external 'EXPAT.DLL'
                                                   name 'XML_SetExternalEntityRefHandler';
procedure XML_SetExternalEntityRefHandlerArg;      external 'EXPAT.DLL'
                                                   name 'XML_SetExternalEntityRefHandlerArg';
procedure XML_SetUnknownEncodingHandler;           external 'EXPAT.DLL'
                                                   name 'XML_SetUnknownEncodingHandler';
function XML_SetParamEntityParsing;                external 'EXPAT.DLL'
                                                   name 'XML_SetParamEntityParsing';
procedure XML_DefaultCurrent;                      external 'EXPAT.DLL'
                                                   name 'XML_DefaultCurrent';
procedure XML_SetReturnNSTriplet;                  external 'EXPAT.DLL'
                                                   name 'XML_SetReturnNSTriplet';
procedure XML_SetUserData;                         external 'EXPAT.DLL'
                                                   name 'XML_SetUserData';
function  XML_SetEncoding;                         external 'EXPAT.DLL'
                                                   name 'XML_SetEncoding';
procedure XML_UseParserAsHandlerArg;               external 'EXPAT.DLL'
                                                   name 'XML_UseParserAsHandlerArg';
function  XML_SetBase;                             external 'EXPAT.DLL'
                                                   name 'XML_SetBase';
function  XML_GetBase;                             external 'EXPAT.DLL'
                                                   name 'XML_GetBase';
function  XML_GetSpecifiedAttributeCount;          external 'EXPAT.DLL'
                                                   name 'XML_GetSpecifiedAttributeCount';
function  XML_GetIdAttributeIndex;                 external 'EXPAT.DLL'
                                                   name 'XML_GetIdAttributeIndex';
function  XML_Parse;                               external 'EXPAT.DLL'
                                                   name 'XML_Parse';
function  XML_GetErrorCode;                        external 'EXPAT.DLL'
                                                   name 'XML_GetErrorCode';
function  XML_GetBuffer;                           external 'EXPAT.DLL'
                                                   name 'XML_GetBuffer';
function  XML_ParseBuffer;                         external 'EXPAT.DLL'
                                                   name 'XML_ParseBuffer';
function  XML_ExternalEntityParserCreate;          external 'EXPAT.DLL'
                                                   name 'XML_ExternalEntityParserCreate';
function  XML_GetCurrentLineNumber;                external 'EXPAT.DLL'
                                                   name 'XML_GetCurrentLineNumber';
function  XML_GetCurrentColumnNumber;              external 'EXPAT.DLL'
                                                   name 'XML_GetCurrentColumnNumber';
function  XML_GetCurrentByteIndex;                 external 'EXPAT.DLL'
                                                   name 'XML_GetCurrentByteIndex';
function  XML_GetCurrentByteCount;                 external 'EXPAT.DLL'
                                                   name 'XML_GetCurrentByteCount';
function  XML_GetInputContext;                     external 'EXPAT.DLL'
                                                   name 'XML_GetInputContext';
procedure XML_ParserFree;                          external 'EXPAT.DLL'
                                                   name 'XML_ParserFree';
function  XML_ErrorString;                         external 'EXPAT.DLL'
                                                   name 'XML_ErrorString';
function  XML_ExpatVersion;                        external 'EXPAT.DLL'
                                                   name 'XML_ExpatVersion';

end.
