import java.util.*;
import java.net.*;

public class UDPBridge
{
    public static final int PORT=16500;
    public static final String DOMAIN="ALL-SYSTEMS.MCAST.NET";
    public static final String DELIMITER="|";
    private static byte[] buf = new byte[65509];

    static public void main(String[] args) 
    {
        try
        {
            // Create a UDP socket
            MulticastSocket ms = new MulticastSocket(PORT);
            ms.joinGroup(InetAddress.getByName(DOMAIN));

            // Initialize CORBA connection
            org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(new String[0], null);
            EventLog remoteLog = EventLogHelper.bind(orb);

            while(true) 
            {
                // Receive the message
                DatagramPacket dp = new DatagramPacket(buf, buf.length);
                ms.receive(dp);

                // Parse the event
                String s = new String(dp.getData(), 0, 0, dp.getLength());
                StringTokenizer t = new StringTokenizer(s, DELIMITER);

                // Send the event message to the Event Log Service
		String remoteHost = dp.getAddress().getHostName();
                remoteLog.log(remoteHost, t.nextToken(), t.nextToken(), t.nextToken());
            }
        }
        catch(Exception e)
        {
        }
    }
}
