/*
 * Copyright (c) 2001 by Cliff Berg.
 * This code may be used and distributed for research for purposes.
 * No warrantee of any kind is given or implied.
 */

package mc.rmi;

public class ChainedException extends Exception
{
	public ChainedException()
	{
		super();
	}

	public ChainedException(String msg)
	{
		super(msg);
	}

	public ChainedException(Throwable t)
	{
		this.throwable = t;
	}

	public ChainedException(Throwable t, String msg)
	{
		this.throwable = t;
		this.msg = msg;
	}

	public Throwable getNestedThrowable() { return throwable; }

	/**
	 * Print all chained exceptions.
	 */
	public void printStackTrace()
	{
		super.printStackTrace();
		Throwable t = getNestedThrowable();
		if (t == null) return;
		System.out.println("Nested exception:");
		t.printStackTrace();
	}

	private Throwable throwable;
	private String msg;
}

