/*
 * Copyright (c) 2001 by Cliff Berg.
 * This code may be used and distributed for research for purposes.
 * No warrantee of any kind is given or implied.
 */

package mc.rmi;

public interface Configurator
{
	/**
	 * Configure a new service object based on the local configuration
	 * requirements. This assumes that the object has already been
	 * configured remotely by the service provider that created the new
	 * instance. Here we are primarily concerned with UI-related or
	 * platform-specific configuration - i.e. aspects that the remote
	 * provider service cannot handle.
	 */
	public void configure()
	throws
	 	ConfigurationAlert,
	 	ConfigurationFailure;

	public void dispose();

	public void setService(Service s);

	public Service getService();
}
