/*
 * Copyright (c) 2001 by Cliff Berg.
 * This code may be used and distributed for research for purposes.
 * No warrantee of any kind is given or implied.
 */

package mc.rmi;

import java.util.SortedSet;
import java.util.TreeSet;
import java.util.Iterator;
import java.util.NoSuchElementException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.IOException;

public class MCLocalReference extends LocalReferenceBase
{
	public MCLocalReference(ConfigRuntime r, Object localState)
	{
		super(r, localState);
	}

	// ------------------------------------------------------------
	// Serialization override methods.

	private void writeObject(ObjectOutputStream stream)
	throws
		IOException
	{
		// Nothing to write, because when this local reference is
		// restored, its fields will either be restored as needed,
		// or will be restored by the superclass constructor.

		stream.defaultWriteObject();
	}

	private void readObject(ObjectInputStream stream)
	throws
		IOException,
		ClassNotFoundException
	{
		stream.defaultReadObject();

		setRuntime(RuntimeRegistry.getRuntime());
	}
}
