/*
 * Copyright (c) 2001 by Cliff Berg.
 * This code may be used and distributed for research for purposes.
 * No warrantee of any kind is given or implied.
 */

package mc.rmi;

public interface NullificationListener
{
	/**
	 * Called by the runtime when the local reference is cleared.
	 */
	public void referenceHasBeenCleared();

	/**
	 * Called by the runtime if the service becomes available
	 * again.
	 */
	public void referenceHasBeenSet();

	/**
	 * Return the local reference to the listener. This makes it
	 * possible to check if the local reference is not empty (and
	 * hence the listener still exists).
	 */
	public LocalReference getListenersLocalReference();
}
