/*
 * Copyright (c) 2001 by Cliff Berg.
 * This code may be used and distributed for research for purposes.
 * No warrantee of any kind is given or implied.
 */

package mc.rmi;

import java.io.Serializable;

public interface ServiceState extends Serializable
{
	public static final ServiceState Uninitialized = new ServiceStateImpl();
	public static final ServiceState Initialized = new ServiceStateImpl();
	public static final ServiceState Started = new ServiceStateImpl();

	public boolean isInitializedOrStarted();
	public boolean isStarted();

	public class ServiceStateImpl implements ServiceState
	{
		public boolean isInitializedOrStarted()
		{
			return (this == Initialized) || (this == Started);
		}

		public boolean isStarted()
		{
			return (this == Started);
		}
	}
}


