/*
 * Copyright (c) 2001 by Cliff Berg.
 * This code may be used and distributed for research for purposes.
 * No warrantee of any kind is given or implied.
 */

package mc.rmi;

public interface UpdateableService extends Service
{
	/**
	 * Clone this obtect's remote state and return it.
	 * The remote state encapsulates the portion of this object's state that
	 * can be configured remotely when this object is updated.
	 */
	public RemoteState copyRemoteState();

	/**
	 * Create and return a local (managed) reference to this object's local
	 * state. The local state encapsulates the portion of this object's
	 * state that cannot be configured remotely when this object is updated.
	 */
	public LocalReference getLocalState();
}
